package kalaha;

// <editor-fold defaultstate="collapsed" desc=" UML Marker ">
// #[regen=yes,id=DCE.B52C7A1E-8F5B-AD75-CABA-7AFA7282D099]
// </editor-fold>
public class Cases {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,id=DCE.46FC3F11-5111-9F96-DC46-2E2F5826E550]
    // </editor-fold>
    public Cases() {
    }
    int[] casesJoueur = new int[6];
    int[] kalahaJ = new int[1];
    int[] casesAdv = new int[6];
    int[] kalahaA = new int[1];
    int cpt = 0;
    int cptcase = 1;
    //int testFamine = 0;
    boolean rejoue = false;
// méthode pour initialiser le jeu, mettre les "graines" dans les cases.

    public void Début() {
        for (int i = 0; i < casesJoueur.length; i++) {
            casesJoueur[i] = 3;

        }
        for (int i = 0; i < casesAdv.length; i++) {
            casesAdv[i] = 3;

        }
        kalahaJ[0] = 0;
        kalahaA[0] = 0;
    }
//méthode s'occupant de la partie du joueur 1

    public void CoupJ(int nb)
    {
        rejoue = false;
        cpt = casesJoueur[nb];
        casesJoueur[nb] = 0;

        while (cpt != 0)
        {
            //déplacement des graines dans les cases du joueur 1
            for (int i = nb + 1; i < casesJoueur.length; i++)
            {
                if (cpt != 0)
                {
                    casesJoueur[i] = casesJoueur[i] + 1;
                    cpt -= 1;

                    // test pour prendre sa propre case et celle de
                    // l'adversaire si on termine dans une case vide
                    if (cpt == 0 && casesJoueur[i] == 1)
                    {
                        cptcase += casesAdv[(casesAdv.length-1) - i];
                        casesAdv[(casesAdv.length-1) - i] = 0;
                        casesJoueur[i] = 0;

                        kalahaJ[0] += cptcase;
                        cptcase = 1;
                    }
                }
            }

            // implementation du kahala du joueur 1
            if (cpt != 0)
            {
                kalahaJ[0] += 1;
                cpt -= 1;
                // test si la dernière graine a été mise dans le kahala
                if(cpt == 0)
                {
                    rejoue = true;
                }
            }

            //déplacement des graines dans les cases de l'adveraire
            if (cpt != 0)
            {
                for (int i = 0; i < casesAdv.length; i++)
                {
                    if (cpt != 0) {
                        casesAdv[i] += 1;
                        cpt -= 1;
                    }
                }
            }

            // implementation du kahala de l'adversaire
            if (cpt != 0)
            {
                kalahaA[0] += 1;
                cpt -= 1;
            }

            // boucle jusqu'au point de départ
            for (int i = 0; i < nb + 1; i++)
            {
                if (cpt != 0)
                {
                    casesJoueur[i] = casesJoueur[i] + 1;
                    cpt -= 1;

                    // test pour prendre sa propre case et celle de
                    // l'adversaire si on termine dans une case vide
                    if (cpt == 0 && casesJoueur[i] == 1)
                    {
                        cptcase += casesAdv[(casesAdv.length-1) - i];
                        casesAdv[(casesAdv.length-1) - i] = 0;
                        casesJoueur[i] = 0;

                        kalahaJ[0] += cptcase;
                        cptcase = 1;
                    }
                }
            }

            //recommence du début, si reste
        }
        /* for (int i = 0; i < casesJoueur.length; i++) {
        testFamine += casesJoueur[i];
        }
        if (testFamine == 0) {
        int Famine = 0;
        for (int i = 0; i < casesAdv.length; i++) {
        Famine += casesAdv[i];
        casesAdv[i] = 0;
        }
        kalahaA[0] += Famine;
        }*/


    }
//méthode s'occupant de la partie du joueur 2

    public void CoupA(int nb) {
        rejoue = false;

        cpt = casesAdv[nb];
        casesAdv[nb] = 0;

        while (cpt != 0) {
 // déplacement des graines dans les cases du joueur 2
            for (int i = nb + 1; i < casesAdv.length; i++) {
                if (cpt != 0) {
                    casesAdv[i] += 1;
                    cpt -= 1;
// test pour prendre sa propre case et celle de l'adversaire si on termine dans une case vide
                    if (cpt == 0 && casesAdv[i] == 1) {
                        switch (i) {
                            case 0:
                                cptcase += casesJoueur[5];
                                casesJoueur[5] = 0;
                                casesAdv[0] = 0;
                                break;
                            case 1:
                                cptcase += casesJoueur[4];
                                casesJoueur[4] = 0;
                                casesAdv[1] = 0;
                                break;
                            case 2:
                                cptcase += casesJoueur[3];
                                casesJoueur[3] = 0;
                                casesAdv[2] = 0;
                                break;
                            case 3:
                                cptcase += casesJoueur[2];
                                casesJoueur[2] = 0;
                                casesAdv[3] = 0;
                                break;
                            case 4:
                                cptcase += casesJoueur[1];
                                casesJoueur[1] = 0;
                                casesAdv[4] = 0;
                                break;
                            case 5:
                                cptcase += casesJoueur[0];
                                casesJoueur[0] = 0;
                                casesAdv[5] = 0;
                                break;

                        }
                        kalahaA[0] += cptcase;
                        cptcase = 1;


                    }
                }
            }
// déplacement des des graines dans le Kahala du joueur 2
            if (cpt != 0) {
                kalahaA[0] += 1;
                cpt -= 1;
                // test si la dernière graine a été mise dans le kahala
                if(cpt == 0){
                    rejoue = true;
                }
            }
// déplacement des graines dans les cases du joueur 1
            if (cpt != 0) {
                for (int i = 0; i < casesJoueur.length; i++) {
                    if (cpt != 0) {
                        casesJoueur[i] += 1;
                        cpt -= 1;
                    }
                }
            }
        }
        /*for (int i = 0; i < casesAdv.length; i++) {
        testFamine += casesAdv[i];
        }
        if (testFamine == 0) {
        int Famine = 0;
        for (int i = 0; i < casesJoueur.length; i++) {
        Famine += casesJoueur[i];
        casesJoueur[i] = 0;

        }
        kalahaJ[0] += Famine;
        }*/

    }

// méthode indiquant si l'un des joueur doit rejouer
   /* public boolean testRejouer(){
        return rejoue;

    }*/
}

